;;;;
;;;; Text routines
;;;;


print16:		move.l	#15,d5		; height
				move.l	#160,d6		; bitmap width (destination)
				lea		fullfont_jag,a6
				
				move.l	a1,a5
				
.printloop:		moveq	#0,d0
				move.b	(a0)+,d0		; get char

				cmp.b	#-4,d0
				beq		.linefeed
				cmp.b	#-3,d0
				beq		.halfspace
				tst.b	d0
				bpl.s	.plotter
				rts
				
.halfspace:		lea		4(a1),a1
				bra		.printloop

.linefeed:		lea		160*16(a5),a5
				move.l	a5,a1
				bra		.printloop
				
;; chars are:  8x16 bytes each = 128
	
.plotter:		sub.b	#' ',d0
				move.l	a1,a3
				move.l 	a6,a2
				asl.w	#7,d0			; *128
				add.l	d0,a2			; now points to char
				
				move.l	d5,d7			; #15,d7
.char:			move.l	(a2)+,(a3)
				move.l	(a2)+,4(a3)
				add.l	d6,a3
				dbra	d7,.char
		
				lea		8(a1),a1
				bra		.printloop


textblock_y:		dc.l	0
textblock_dir:		dc.l	0
textblock_count:	dc.l	0
textblock_hold:		dc.l	0
textblock_text:		dc.l	0
				
title_writer:	tst.l	textblock_hold
				bpl		hold_block

				sub.l	#1,textblock_count
				bmi		swap_dir
				
				move.l	textblock_dir,d0
				add.l	d0,textblock_y

				move.l	textblock_obj,a0			; put title logo on screen
				move.l	#0,d0
				move.l	textblock_y,d1
				jsr		setup_object_xy	
				rts
				
swap_dir:		neg.l	textblock_dir
				move.l	#100,textblock_count
				tst.l	textblock_dir
				bmi.s	redraw_titletext
				move.l	#5*60,textblock_hold
				rts
				
redraw_titletext:
				lea		textblock_jag,a0
				move.l	#((160*64)/4)-1,d7
eraser:			clr.l	(a0)+
				dbra	d7,eraser
				
				move.l	textblock_text,d0
				asl.l	#2,d0
				lea		textblock_wordings,a0
				tst.l	(a0,d0.w)
				bpl.s	.ok
				moveq	#0,d0
				move.l	d0,textblock_text
.ok:			move.l	(a0,d0.w),a0
				lea		textblock_jag,a1
				bsr		print16
				add.l	#1,textblock_text
				rts
				
hold_block:		subq.l	#1,textblock_hold
				rts
	
textblock_wordings:
				dc.l	title_text1, title_text2, title_text3, title_text4, title_text5, title_text6, title_text7, title_text8, title_text9, title_text10, title_text11, title_text12, title_text13, title_text14, title_text15, title_text16, title_text17, title_text18, title_text19, title_text20, title_text21
				dc.l	-1
	
;;				dc.b	"01234567890123456789"
	
title_text1:	dc.b	-3,"WELCOME TO DOWNFALL",-4 		; Sauron sez hi!!!!111eleventyone
				dc.b	-4
				dc.b	   "  (C) MMXI REBOOT",-4
				dc.b	-3,"ALL RIGHTS RESERVED",-1
				
title_text2:	dc.b	-3,"  PRESS B TO PLAY  ",-4
				dc.b	-4
				dc.b	   "   OR CONTINUE TO  ",-4
				dc.b	   "  READ THE CREDITS ",-1

title_text3:	dc.b	-3," PICK UP FRUIT FOR  ",-4
				dc.b	   " MOAR POINTS AND TO ",-4
				dc.b	-3,"ENABLE BONUS ITEMS!",-4
				dc.b	-3,"HOW LOW CAN YOU GO?",-1

title_text4:	dc.b	"        CODE       ",-4
				dc.b	-4
				dc.b	"    CYRANO JONES   ",-4
				dc.b	"     AND SAURON    ",-1

title_text5:	dc.b	   "      GRAPHICS      ",-4
				dc.b	-4
				dc.b	-3,"        NEO       ",-4
				dc.b	-3,"      SHTHREE     ",-1
				
title_text6:	dc.b	-3,"       MUSIC      ",-4
				dc.b	-4
				dc.b	-4
				dc.b	-3,"        MSG       ",-1
				
title_text7:	dc.b	"       SPEECH      ",-4
				dc.b	-4
				dc.b	-4
				dc.b	"       STEVEN      ",-1

title_text8:	dc.b	-3,"    PLAYTESTING:   ",-4
				dc.b	-4
				dc.b	"  SHAUN   CHRISTOS ",-4
				dc.b	"    REMOWILLIAMS   ",-1

title_text9:	dc.b	-3,"    PLAYTESTING:  ",-4
				dc.b	-4
				dc.b	   "      PARTYCLE    ",-4
				dc.b	-3,"        GGN    ",-1
				
title_text10:	dc.b	-3,"       STORY      ",-4
				dc.b	-4
				dc.b	-4
				dc.b	"      CHRISTOS      ",-1
				
title_text11:	dc.b	-3," ORIGINAL CONCEPT: ",-4
				dc.b	-4
				dc.b	-3,"MAN GOES DOWN (VCS)",-4
				dc.b	-3,"  BY ALEX HERBERT  ",-1
				
title_text12:	dc.b	-3,"REBOOT SENDS GREETS",-4
				dc.b	-4
				dc.b	"  TO THE FOLLOWING: ",-1
				
title_text13:	dc.b	"      JAGWARE:       ",-4
				dc.b	-4
				dc.b	" ZEROSQUARE   SCPCD ",-4
				dc.b	" MATMOOK   GT-TURBO ",-1
				
title_text14:	dc.b	" FADEST        BEAR ",-4
				dc.b	" FREDIFREDO     SEB ",-4
				dc.b	" GREGG          RAZ ",-1
				
title_text15:	dc.b	"      SINIGORD      ",-4
				dc.b	" (FOR THE DSP CODE) ",-4
				dc.b	-4
				dc.b	-3,"      STARCAT",-1
								
title_text16:	dc.b	" MATTHIAS    TYRANT ",-4
				dc.b	" GROOVYBEE   BELBOZ ",-4
				dc.b	" DR. CLU    WOZENCL ",-4
				dc.b	-3,"    OVALBUGGMAN    ",-1
				
title_text17:	dc.b	" ORION          BMX ",-4
				dc.b	" COOPER        CD-I ",-4
				dc.b	"   NICE AND GAMES   ",-4
				dc.b	"     PIX'N LOVE     ",-1
				
title_text18:	dc.b	" AUSTIN     KGENTHE ",-4
				dc.b	-3,"     JUSTCLAWS      ",-4
				dc.b	-3,"   THE.GOLDEN.AX   ",-4
				dc.b	"    JAMES GARVIN    ",-1
				
title_text19:	dc.b	-3,"  ATARIAGE STAFF:  ",-4
				dc.b	-4
				dc.b	" ALBERT      CPUWIZ ",-4
				dc.b	" TEMPEST   PUNISHER ",-1
				
title_text20:	dc.b	" AND ALL WHO BOUGHT ",-4
				dc.b	-3,"  SUPERFLY DX AND  ",-4
				dc.b	"    BEEBRIS: SE!    ",-1
				
title_text21:	dc.b	" REBOOT WILL RETURN ",-4
				dc.b	" PLEASE VISIT US AT",-4
				dc.b	"  REBOOT.ATARI.ORG ",-4
				dc.b	"  FOR FURTHER INFO",-1
				
				.even
				
				
				